﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace videosync
{
    class Vlc
    {
        [UnmanagedFunctionPointerAttribute(CallingConvention.Cdecl)]
        public delegate void Callback(IntPtr vevent, IntPtr data);
        const CallingConvention cc = CallingConvention.Cdecl;


        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern IntPtr libvlc_new(int argc, string[] argv);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern IntPtr libvlc_media_new_path(IntPtr instance, string path);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern IntPtr libvlc_media_player_new_from_media(IntPtr media);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_set_media(IntPtr player, IntPtr media);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern IntPtr libvlc_media_player_event_manager(IntPtr player);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern int libvlc_event_attach(IntPtr evmgr, int ev_type, Callback f_callback, IntPtr user_data);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern int libvlc_media_player_play(IntPtr player);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_set_time(IntPtr player, Int64 time);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_set_pause(IntPtr player, int pause);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_stop(IntPtr player);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_release(IntPtr player);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_release(IntPtr media);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_release(IntPtr instance);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern int libvlc_audio_set_volume(IntPtr player, int vol);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern void libvlc_media_player_set_hwnd(IntPtr player, IntPtr drawable);
        [DllImport("libvlc.dll", CallingConvention = cc)]
        public static extern IntPtr libvlc_get_version();

        /*
        public struct vlc_instance { }
        public struct vlc_media_player { }
        public struct vlc_media { }
        public struct vlc_event_manager { }
        
        (doesn't work, just use IntPtrs and don't mix them up)
         */
    }

    enum VlcEvent
    {
        MediaMetaChanged = 0,
        MediaSubItemAdded,
        MediaDurationChanged,
        MediaParsedChanged,
        MediaFreed,
        MediaStateChanged,
        MediaSubItemTreeAdded,

        MediaPlayerMediaChanged = 0x100,
        MediaPlayerNothingSpecial,
        MediaPlayerOpening,
        MediaPlayerBuffering,
        MediaPlayerPlaying,
        MediaPlayerPaused,
        MediaPlayerStopped,
        MediaPlayerForward,
        MediaPlayerBackward,
        MediaPlayerEndReached,
        MediaPlayerEncounteredError,
        MediaPlayerTimeChanged,
        MediaPlayerPositionChanged,
        MediaPlayerSeekableChanged,
        MediaPlayerPausableChanged,
        MediaPlayerTitleChanged,
        MediaPlayerSnapshotTaken,
        MediaPlayerLengthChanged,
        MediaPlayerVout,

        MediaListItemAdded = 0x200,
        MediaListWillAddItem,
        MediaListItemDeleted,
        MediaListWillDeleteItem,

        MediaListViewItemAdded = 0x300,
        MediaListViewWillAddItem,
        MediaListViewItemDeleted,
        MediaListViewWillDeleteItem,

        MediaListPlayerPlayed = 0x400,
        MediaListPlayerNextItemSet,
        MediaListPlayerStopped,

        MediaDiscovererStarted = 0x500,
        MediaDiscovererEnded,

        VlmMediaAdded = 0x600,
        VlmMediaRemoved,
        VlmMediaChanged,
        VlmMediaInstanceStarted,
        VlmMediaInstanceStopped,
        VlmMediaInstanceStatusInit,
        VlmMediaInstanceStatusOpening,
        VlmMediaInstanceStatusPlaying,
        VlmMediaInstanceStatusPause,
        VlmMediaInstanceStatusEnd,
        VlmMediaInstanceStatusError
    };
}
